package org.apache.bcel.classfile;

import java.io.IOException;
import java.io.DataOutputStream;

public class AnnotationElementValue extends ElementValue
{
    private final AnnotationEntry annotationEntry;
    
    public AnnotationElementValue(final int type, final AnnotationEntry annotationEntry, final ConstantPool cpool) {
        super(type, cpool);
        if (type != 64) {
            throw new IllegalArgumentException("Only element values of type annotation can be built with this ctor - type specified: " + type);
        }
        this.annotationEntry = annotationEntry;
    }
    
    @Override
    public void dump(final DataOutputStream dos) throws IOException {
        dos.writeByte(super.getType());
        this.annotationEntry.dump(dos);
    }
    
    public AnnotationEntry getAnnotationEntry() {
        return this.annotationEntry;
    }
    
    @Override
    public String stringifyValue() {
        return this.annotationEntry.toString();
    }
    
    @Override
    public String toString() {
        return this.stringifyValue();
    }
}
